"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const SequencePanel_1 = __importDefault(require("@jbrowse/core/BaseFeatureWidget/SequencePanel"));
const seqpanel_api_1 = __importDefault(require("../seqpanel-api"));
/*
 * Example implementation looks like
 *
 *  root.render(
        <GenericSeqPanel
          refseq="X"
          start="13201770"
          end="13216729"
          gene="WBGene00006749"
          transcript="R12H7.1a.2"
          mode="protein"
          nclistbaseurl="https://s3.amazonaws.com/agrjbrowse/MOD-jbrowses/WormBase/WS287/c_elegans_PRJNA13758/"
          urltemplate="tracks/Curated_Genes/{refseq}/trackData.jsonz"
          fastaurl="https://s3.amazonaws.com/wormbase-modencode/fasta/current/c_elegans.PRJNA13758.WS284.genomic.fa.gz"
        />
    )
 *
 *
 */
// Create a new component that renders a div
// and calls the API to get the sequence
// and then renders the sequence
function GenericSeqPanel(props) {
    const [result, setResult] = (0, react_1.useState)();
    const [error, setError] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        (() => __awaiter(this, void 0, void 0, function* () {
            try {
                setResult(yield (0, seqpanel_api_1.default)(props));
            }
            catch (e) {
                setError(e);
            }
        }))();
    }, [props]);
    if (error) {
        return react_1.default.createElement("div", { style: { color: "red" } }, `${error}`);
    }
    else if (!result) {
        return react_1.default.createElement("div", null, "Loading...");
    }
    else {
        return (react_1.default.createElement("div", { className: "GenericSeqPanel" },
            react_1.default.createElement(SequencePanel_1.default, { mode: props.mode, sequence: result.sequence, feature: result.feature })));
    }
}
exports.default = GenericSeqPanel;
